﻿namespace Metracon.Yomingo.Web
{
	using System;
	using Syncfusion.JavaScript.DataVisualization.DiagramEnums;
	using Syncfusion.JavaScript.DataVisualization.Models.Collections;
	using Syncfusion.JavaScript.DataVisualization.Models.Diagram;
	using Syncfusion.JavaScript.Web;

	public partial class EliminationChart : System.Web.UI.Page
	{
		protected void Page_Load(object sender, EventArgs e)
		{
			var eliminationChart = new Diagram();
			eliminationChart.ID = "EliminationChart";
			eliminationChart.Height = "600px";
			eliminationChart.Width = "100%";
			eliminationChart.Layout.Type = LayoutTypes.HierarchicalTree;
			eliminationChart.Layout.Orientation = LayoutOrientations.RightToLeft;
			eliminationChart.Layout.HorizontalSpacing = 25;
			eliminationChart.Layout.VerticalSpacing = 35;
			eliminationChart.Layout.Margin.Left = 0;
			eliminationChart.Layout.Margin.Top = 20;
			eliminationChart.ClientIDMode = System.Web.UI.ClientIDMode.Static;
			eliminationChart.PageSettings.ScrollLimit = ScrollLimit.Diagram;
			eliminationChart.SelectedItems.Constraints = ~SelectorConstraints.Rotator & ~SelectorConstraints.Resizer;
			eliminationChart.SnapSettings.SnapConstraints = SnapConstraints.None;
			eliminationChart.Model.SelectionChange = "selectionChange";
			eliminationChart.EnableContextMenu = false;
			eliminationChart.Tool = Tool.SingleSelect;
			eliminationChart.NodeTemplate = "nodeTemplate";

// This is doesn't work
			eliminationChart.OnClientDrag = @"function (args) { console.log(args); }";

			// Setup element defauts
			eliminationChart.Model.DefaultSettings.Node = new Node()
			{
				Constraints = NodeConstraints.Select | NodeConstraints.Drag | NodeConstraints.PointerEvents,
				Width = 140,
				Height = 30,
				BorderWidth = 1
			};
			eliminationChart.Model.DefaultSettings.Node.Labels.Add(new Label() { ReadOnly = true });
			eliminationChart.Model.DefaultSettings.Connector = new Connector()
			{
				LineColor = "#000000",
				Constraints = ConnectorConstraints.None,
				Segments = new Collection() { new Segment(Segments.Orthogonal) { Direction = "right" } },
				TargetDecorator = new Decorator() { Shape = DecoratorShapes.None }
			};

			eliminationChart.Nodes.Add(CreateNode("root", "Test"));

			var divDiagram = this.FindControl("diagram");
			divDiagram.Controls.Add(eliminationChart);
		}

		private static Syncfusion.JavaScript.DataVisualization.Models.Diagram.FlowShape CreateNode(string oid, string text)
		{
			var node = new Syncfusion.JavaScript.DataVisualization.Models.Diagram.FlowShape()
			{
				Name = oid,
				Labels = new Collection() { new Label() { Text = text } }
			};

			return node;
		}
	}
}